function [best_val, best_hps] = get_best(results)
  
  best_val = struct("ndcg1", 0, "ndcg10", 0, "hlu", 0, "map", 0, "auc", 0);
  best_hps = struct("ndcg1", "", "ndcg10", "", "hlu", "", "map", "", "auc", "");

  metric_names = ["hlu", "map", "auc"];
  results_names = fieldnames(results);
  for idx = 1:length(results_names)
    res_name = string( results_names(idx) );
	res = getfield(results, res_name);

	% hlu, map and auc
    for met_idx = 1:length(metric_names)
	  met_name = string( metric_names(met_idx) );
	  res_val = getfield(res, met_name);
	  b_val = getfield(best_val, met_name);
	  if b_val < res_val
	    best_val = setfield(best_val, met_name, res_val);
		best_hps = setfield(best_hps, met_name, res_name);
	  elseif b_val == res_val
	    tmp_name = getfield(best_hps, met_name);
	    best_hps = setfield(best_hps, met_name, [tmp_name, res_name]);
	  end
	end

    % ndcg1 and ndcg10
	met_name = "ndcg1";
	res_ndcg = res.ndcg;
	res_val = res_ndcg(1);
    b_val = getfield(best_val, "ndcg1");
    if b_val < res_val
	  best_val = setfield(best_val, met_name, res_val);
	  best_hps = setfield(best_hps, met_name, res_name);
	elseif b_val == res_val
	  tmp_name = getfield(best_hps, met_name);
	  best_hps = setfield(best_hps, met_name, [tmp_name, res_name]);
	end

	met_name = "ndcg10";
	res_val = res_ndcg(10);
    b_val = getfield(best_val, "ndcg10");
    if b_val < res_val
	  best_val = setfield(best_val, met_name, res_val);
	  best_hps = setfield(best_hps, met_name, res_name);
	elseif b_val == res_val
	  tmp_name = getfield(best_hps, met_name);
	  best_hps = setfield(best_hps, met_name, [tmp_name, res_name]);
	end

  end

end
